/*
 * shift_brite.h
 *
 *  Created on: Apr 26, 2012
 *      Author: Thinh Duong
 */
#ifndef _SHIFT_BRITE_H_
#define _SHIFT_BRITE_H_
#ifdef __cplusplus
extern "C" {
#endif

typedef union ShiftBritePacket
{
    unsigned long value;
    struct
    {
        unsigned greenDotCorrect:7;
        unsigned clockMode:2;
        unsigned :1;
        unsigned redDotCorrect:7;
        unsigned :3;
        unsigned blueDotCorrect:7;
    };
    struct
    {
        unsigned green:10;
        unsigned red:10;
        unsigned blue:10;
        unsigned command:1;
    };
} ShiftBritePacket;

ShiftBritePacket colorPacket(unsigned int red, unsigned int green, unsigned int blue);

ShiftBritePacket commandPacket(unsigned int redDotCorrect, unsigned int greenDotCorrect,
                               unsigned int blueDotCorrect, unsigned char clockMode);

void latch();
void latchLow();
void sendPacket(ShiftBritePacket shiftbrite_packet);
void latchHigh();
void sendColorWheelPacket(unsigned int location_on_wheel);




#ifdef __cplusplus
}
#endif
#endif

