#include "carControl.h"
#include "../drivers/ssp_spi.h"
#include "../osHandles.h"
#include "../utils/rprintf.h"
#include "../utils/vector.hpp"
#include "../utils/cString.h"
#include "../drivers/i2c.h"
#include <stdlib.h>                 // atoi()
#include <stdio.h>                  // printf() or iprintf()
#include <string.h>                 // strtok()
#include "../drivers/motor.h"
#include "../drivers/pwm.h"
#include "adjd_s311.hpp"
#include "../utils/rprintf.h"
#include <algorithm>
using namespace std;

void getColor(void *p)
{
	int r = 'r';
	int b = 'b';
	int g = 'g';
	int n = 'n';
	int maxred, maxblue, maxgreen;
	RGBC redInit, blueInit, greenInit;
	OSHANDLES *osHandles = (OSHANDLES*) p;
	//get initial values from queue
	/*xQueueReceive(osHandles->queue.initValues, &redInit.red, portMAX_DELAY);
	xQueueReceive(osHandles->queue.initValues, &redInit.green, portMAX_DELAY);
	xQueueReceive(osHandles->queue.initValues, &redInit.blue, portMAX_DELAY);
	rprintf("redinit = R %i G = %i B = %i\n", redInit.red, redInit.green, redInit.blue);
	maxred = redInit.blue;
	rprintf("red blue = %i\n", maxred);

	xQueueReceive(osHandles->queue.initValues, &greenInit.red, portMAX_DELAY);
	xQueueReceive(osHandles->queue.initValues, &greenInit.green, portMAX_DELAY);
	xQueueReceive(osHandles->queue.initValues, &greenInit.blue, portMAX_DELAY);
	rprintf("greeninit = R %i G = %i B = %i\n", greenInit.red, greenInit.green, greenInit.blue);
	//maxgreen = max(greenInit.red, greenInit.blue);
	//maxgreen = max(maxgreen, greenInit.green);
	maxgreen = greenInit.blue;
		rprintf("green sum = %i\n", maxgreen);

	xQueueReceive(osHandles->queue.initValues, &blueInit.red, portMAX_DELAY);
	xQueueReceive(osHandles->queue.initValues, &blueInit.green, portMAX_DELAY);
	xQueueReceive(osHandles->queue.initValues, &blueInit.blue, portMAX_DELAY);
	rprintf("blueinit = R %i G = %i B = %i\n", blueInit.red, blueInit.green, blueInit.blue);
	//maxblue = max(blueInit.red, blueInit.blue);
	//maxblue = max(maxblue, blueInit.green);
	maxblue = blueInit.blue;
			rprintf("blue sum = %i\n", maxblue);
*/
	while (1)
	{
		rprintf("entered while loop\n");
		getOffset();
		performMeasurement();
		int red = readRegisterInt(DATA_RED_LO);
		int blue = readRegisterInt(DATA_BLUE_LO);
		int green = readRegisterInt(DATA_GREEN_LO);
		for (int i = 0; i < 75; i++)
		{
			performMeasurement();
			red += readRegisterInt(DATA_RED_LO);
			red /= 2;
			blue += readRegisterInt(DATA_BLUE_LO);
			blue /= 2;
			green += readRegisterInt(DATA_GREEN_LO);
			green /= 2;
		}

		if (blue == 0)
		{
			xQueueSend(osHandles->queue.colorValue,&n,10);
			rprintf("sent none\n");
		}
		else if ((blue > 11000))
		{
			xQueueSend(osHandles->queue.colorValue, &b ,10);
			rprintf("sent blue\n");
		}
		else if (blue > 5500)
		//((red > green) && (red > blue))
		{
			xQueueSend(osHandles->queue.colorValue,&r,10);
			rprintf("sent red\n");
		}
		else if (blue > 3500)
		//((green > red) && (green > blue))
		{
			xQueueSend(osHandles->queue.colorValue,&g,10);
			rprintf("sent green\n");
		}
		else
		{
			xQueueSend(osHandles->queue.colorValue,&n,10);
			rprintf("sent none\n");
		}
	}
}

void controlCar(void *p)
{
	OSHANDLES *osHandles = (OSHANDLES*) p;
	char buffer;
	while (1)
	{
		if(xQueueReceive(osHandles->queue.colorValue, &buffer, portMAX_DELAY))
		{
			rprintf("buffer is %c\n", buffer);
			char b = buffer;
			buffer = (int) b;
			switch (buffer)
			{
			case 'r':
				rprintf("STOP\n");
				changeSpeed(STOP);
				vTaskDelay(2000);
				set_motor_direction(FORWARD);
				changeSpeed(NORMAL);
				vTaskDelay(500);
				break;
			case 'b':
				rprintf("REVERSE\n");
				set_motor_direction(REVERSE);
				changeSpeed(SLOW);
				vTaskDelay(400);
				break;
			case 'g':
				set_motor_direction(FORWARD);
				changeSpeed(FAST);
				break;
			case 'n':
				changeSpeed(NORMAL);
				break;
			default:
				break;
			}
		}
	}
}
RGBC getAverageValues()
{
	getOffset();
	performMeasurement();
	int red = readRegisterInt(DATA_RED_LO);
	int blue = readRegisterInt(DATA_BLUE_LO);
	int green = readRegisterInt(DATA_GREEN_LO);
	for (int i = 0; i < 100; i++)
	{
		performMeasurement();
		red += readRegisterInt(DATA_RED_LO);
		red /= 2;
		blue += readRegisterInt(DATA_BLUE_LO);
		blue /= 2;
		green += readRegisterInt(DATA_GREEN_LO);
		green /= 2;
	}
	RGBC average;
	average.blue = blue;
	average.red = red;
	average.green = green;
	return average;
}

